
if (typeof _497BFC326A484FAC8AB6B8CD0D886127 === "undefined") {
	_497BFC326A484FAC8AB6B8CD0D886127 = {};
}

(function(){

var global = this;

if (global.login === undefined) {
    global.login = {};
}
var g_loginData = {};

global.login.CentrifyBELogin = function() {
	global.login.CentrifyBELoginBase.call(this);
};

global.login.CentrifyBELogin.prototype = {
    setLoginData: function(doc, loginData){
        this.log("setLoginData");
        this.SaveLoginData(loginData);
    },
	
    updateLoginData: function(doc, loginData){
        this.log("updateLoginData");
        this.SaveLoginData(loginData);
    },
	
    end: function(doc) {
        this.log("end");
        if (global.login.centrifyBEShade) {
            global.login.centrifyBEShade.removeShade(doc);
        }
        global.login.CentrifyBELoginBase.prototype.end.call(this, doc);
    },
    
	clearLoginData: function(doc){
        this.log("clearLoginData");
        this.SaveLoginData(null);
	},
	
	notInAppClickPage: function(doc) {
        if (g_loginData && Object.keys(g_loginData).length > 0) {
            this.tryLogin(doc, g_loginData);
        }
	},
	
	/**
	 * @override
	 */
	fireEnterEvents: function(doc, field, fieldData) {
		var selector = fieldData.pattern;
		var injectScript = doc.createElement('script');
		injectScript.textContent = ' \
		if (!_centrifyChromeLoginHelper) { \
			var _centrifyChromeLoginHelper = function(selector) { \
				var field = document.querySelector(selector); \
				var evt = document.createEvent("Event"); \
				evt.initEvent("keydown", true, true); \
				evt.keyCode = 13; \
				evt.which = 13; \
				field.dispatchEvent(evt); \
				\
				evt = document.createEvent("Event"); \
				evt.initEvent("keyup", true, true); \
				evt.keyCode = 13; \
				evt.which = 13; \
				field.dispatchEvent(evt); \
				\
				evt = document.createEvent("Event"); \
				evt.initEvent("keypress", true, true); \
				evt.keyCode = 13; \
				evt.which = 13; \
				field.dispatchEvent(evt); \
				\
				evt = document.createEvent("HTMLEvents"); \
				evt.initEvent("change", true, false); \
				field.dispatchEvent(evt); \
				\
				evt = document.createEvent("TextEvent"); \
				evt.initTextEvent("textInput", true, true, null, "\\n", 9, "en-US"); \
				field.dispatchEvent(evt); \
			} \
		} \
		_centrifyChromeLoginHelper("'+selector+'"); \
		';
		
		(doc.head||doc.documentElement).appendChild(injectScript);
		injectScript.parentNode.removeChild(injectScript);
	},
    
    SaveLoginData: function(loginData) {
        if (loginData && Object.keys(loginData).length > 0) {
            AndroidJsInterface.setLoginData(JSON.stringify(loginData));
            g_loginData = loginData;
        } else {
            AndroidJsInterface.setLoginData(null);
            g_loginData = {};
        }
    }
};

global.common.objectExtend(global.login.CentrifyBELogin, global.login.CentrifyBELoginBase);
global.login.CentrifyBELogin.prototype.constructor  = global.login.CentrifyBELoginBase;
global.login.centrifyBELogin = new global.login.CentrifyBELogin();

global.login.CentrifyBEShade = function() {
    global.login.CentrifyBEShadeBase.call(this);
};

global.login.CentrifyBEShade.prototype = {
    checkIfAddShade: function(doc) {
        if (g_loginData && Object.keys(g_loginData).length > 0) {
            this.addShade(doc);
        }
    }
};

global.common.objectExtend(global.login.CentrifyBEShade, global.login.CentrifyBEShadeBase);
global.login.CentrifyBEShade.prototype.constructor = global.login.CentrifyBELoginBase;
global.login.centrifyBEShade = new global.login.CentrifyBEShade();

global.login.LoginPromptHandler = function() {
	global.login.CentrifyBEHttp401Base.call(this);
};

global.login.LoginPromptHandler.prototype = {
    
    abort: function(carryOver, message) {
        this.logError("android abort");
        AndroidJsInterface.onReceviedHttpBasicCedential(null, null);
        global.login.CentrifyBEHttp401Base.prototype.abort.call(this, carryOver, message);
        this.logError("android abort end");
    },
    
	clearLoginData: function(carryOver) {
		this.logError("clear login data");
		global.login.centrifyBELogin.SaveLoginData(null);
	},

	fillUsernameAndPassword: function(carryOver, username, password) {
		if (username === null || username === undefined || password === null || password === undefined) {
			//should not happen
			this.logError("Failed to find username/password in the loginData");
            AndroidJsInterface.onReceviedHttpBasicCedential(null, null);
		} else {
			this.log("the username and password is filled");
			AndroidJsInterface.onReceviedHttpBasicCedential(username, password);
		}
	},
	
	updateLoginData: function(carryOver, loginData) {
		this.log("update login Data ");
		global.login.centrifyBELogin.SaveLoginData(loginData);
	}
};

global.common.objectExtend(global.login.LoginPromptHandler, global.login.CentrifyBEHttp401Base);
global.login.LoginPromptHandler.prototype.constructor  = global.login.CentrifyBEHttp401Base;
global.login.loginPromptHandler = new global.login.LoginPromptHandler();

global.login.androidonPageFinished = function() {
    var initData = AndroidJsInterface.getLoginData();
    if (initData) {
        g_loginData = JSON.parse(initData, null);
    }
    
    var debugMode = AndroidJsInterface.getDebugMode();
    var debugDelay = AndroidJsInterface.getDebugDelay();
    console.log("debugMode " + debugMode + " debugDelay: " + debugDelay);
    
    global.login.centrifyBEShade.debugMode = debugMode;
    global.login.centrifyBEShade.debugDelay = debugDelay;
    global.login.centrifyBELogin.debugMode = debugMode;
    global.login.centrifyBELogin.debugDelay = debugDelay;
    
    global.login.centrifyBEShade.preCheckPage(document);
    global.login.centrifyBELogin.checkPage(document);
};

global.login.androidonHttpAuthRequest = function() {
    var initData = AndroidJsInterface.getLoginData();
    console.log("android on Http Auth Request");
    if (initData) {
        g_loginData = JSON.parse(initData, null);
    }
    var carryOver = {url:"androidcarryover://fake401call"};
    global.login.loginPromptHandler.debugMode = AndroidJsInterface.getDebugMode();
    global.login.loginPromptHandler.recevied401Header(carryOver, g_loginData);
};

}).call(_497BFC326A484FAC8AB6B8CD0D886127);

function CentrifyBEAndroidonPageLoad() {
    try {
        console.log("Start CentrifyBEAndroidonPageLoad");
        _497BFC326A484FAC8AB6B8CD0D886127.login.androidonPageFinished();
        console.log("End CentrifyBEAndroidonPageLoad");
    } catch (e) {
        console.log(e.message);
    }
}

function CentrifyBEAndroid401CallBack() {
    try {
        console.log("Start httpBasicCallBack");
    	_497BFC326A484FAC8AB6B8CD0D886127.login.androidonHttpAuthRequest();
    	console.log("End httpBasicCallBack");
    } catch (e) {
        AndroidJsInterface.onReceviedHttpBasicCedential(null, null);
        console.log(e.message);
    }
}
